Index: trunk/examples/objects/app-fermi/fermi4.m
===================================================================
--- trunk/examples/objects/app-fermi/fermi4.m	(revision 1581)
+++ trunk/examples/objects/app-fermi/fermi4.m	(revision 1581)
@@ -0,0 +1,67 @@
+% ----------------------------------------------------------------------
+%  EXAMPLE: Fermi-Dirac function in Octave.
+%
+%  This script represents a newly written application with rappture 
+%  bindings and interface.
+%
+% ======================================================================
+%  AUTHOR:  Derrick Kearney, Purdue University
+%  Copyright (c) 2005-2009  Purdue Research Foundation
+%
+%  See the file "license.terms" for information on usage and
+%  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+% ======================================================================
+
+% get out input file from the command line
+% invoke this script with the following command:
+% matlab -nodisplay -r infile=\'driver1234.xml\',fermi
+% the above command sets variable infile to the name 'driver1234.xml'
+
+% infile = 'driver31619.xml'
+
+% open our xml input file.
+lib = Rappture_Library(infile);
+
+nPts = 200;
+
+if (Rappture_Library_error(lib) == 0)) {
+    % cannot open file or out of memory
+    fprintf(stderr, Rappture_Library_traceback(lib));
+    exit(Rappture_Library_error(lib));
+}
+
+T = Rappture_connect(lib,'temperature');
+Ef = Rappture_Library_value(lib,'Ef','units=eV');
+
+if (Rappture_Library_error(lib) == 0) {
+    % there were errors while retrieving input data values
+    % dump the tracepack
+    fprintf(stderr,Rappture_Library_traceback(lib));
+}
+
+% do fermi calculations (science)...
+kT = 8.61734e-5 * Rappture_Number_value(T,'K');
+Emin = Ef - 10*kT;
+Emax = Ef + 10*kT;
+
+EArr = linspace(Emin,Emax,nPts);
+fArr = 1.0 ./ (1.0 + exp((E - Ef)/kT));
+
+
+curveLabel = 'Fermi-Dirac Curve';
+curveDesc = 'Plot of Fermi-Dirac Calculation';
+
+% do it the easy way,
+% create a plot to add to the library
+% plot is registered with lib upon object creation
+% p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
+
+p1 = Rappture_Plot(lib);
+Rappture_Plot_add(p1,nPts,fArr,EArr,"",curveLabel,curveDesc);
+Rappture_Plot_propstr(p1,"xlabel","Fermi-Dirac Factor");
+Rappture_Plot_propstr(p1,"ylabel","Energy");
+Rappture_Plot_propstr(p1,"yunits","eV");
+
+Rappture_Library_result(lib);
+
+quit;
Index: trunk/examples/objects/app-fermi/fermi4.py
===================================================================
--- trunk/examples/objects/app-fermi/fermi4.py	(revision 1581)
+++ trunk/examples/objects/app-fermi/fermi4.py	(revision 1581)
@@ -0,0 +1,122 @@
+#! /usr/bin/env python
+# ----------------------------------------------------------------------
+#  EXAMPLE: Fermi-Dirac function in C++.
+#
+#  This simple example shows how to use Rappture within a simulator
+#  written in C++.
+# ======================================================================
+#  AUTHOR:  Derrick Kearney, Purdue University
+#  Copyright (c) 2005-2009  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+# ======================================================================
+
+
+import sys
+import os
+import getopt
+
+import Rappture
+from math import *
+
+
+def help(argv=sys.argv):
+    return """%(prog)s [-h]
+
+     -h | --help       - print the help menu
+
+     Examples:
+       %(prog)s
+
+""" % {'prog':os.path.basename(argv[0])}
+
+def main(argv=None):
+
+    if argv is None:
+        argv = sys.argv
+
+    if len(argv) < 1:
+        msg = "%(prog)s requires at least 0 argument" % {'prog':argv[0]}
+        print >>sys.stderr, msg
+        print >>sys.stderr, help()
+        return 2
+
+    longOpts = ["help"]
+    shortOpts = "h"
+    try:
+        opts,args = getopt.getopt(argv[1:],shortOpts,longOpts)
+    except getopt.GetOptError, msg:
+        print >>sys.stderr, msg
+        print >>sys.stderr, help()
+        return 2
+
+
+
+    # create a rappture library from the file filePath
+    lib = Rappture.Library(argv[1])
+
+#    T = Rappture.Number();
+#    Ef = 0.0;
+#    dE = 0.0;
+#    kT = 0.0;
+#    Emin = 0.0;
+#    Emax = 0.0;
+    nPts = 200;
+    EArr = list() # [nPts];
+    fArr = list() # [nPts];
+
+    if (lib.error() != 0) {
+        # cannot open file or out of memory
+        print >>sys.stderr, lib.traceback()
+        exit(lib.error());
+    }
+
+    T = Rappture.connect(lib,"temperature");
+    Ef = lib.value("Ef","units=eV");
+
+    if (lib.error() != 0) {
+        # there were errors while retrieving input data values
+        # dump the tracepack
+        print >>sys.stderr, lib.traceback()
+        exit(lib.error());
+    }
+
+    kT = 8.61734e-5 * T.value("K");
+    Emin = Ef - 10*kT;
+    Emax = Ef + 10*kT;
+
+    dE = (1.0/nPts)*(Emax-Emin);
+
+    E = Emin;
+    for (size_t idx = 0; idx < nPts; idx++) {
+        E = E + dE;
+        f = 1.0/(1.0 + exp((E - Ef)/kT));
+        fArr.append(f);
+        EArr.append(E);
+        Rappture.Utils.progress((int)((E-Emin)/(Emax-Emin)*100),"Iterating");
+    }
+
+    curveLabel = "Fermi-Dirac Curve"
+    curveDesc = "Plot of Fermi-Dirac Calculation";
+
+    # do it the easy way,
+    # create a plot to add to the library
+    # plot is registered with lib upon object creation
+    # p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
+
+    p1 = Rappture.Plot(lib);
+    p1.add(nPts,fArr,EArr,"",curveLabel,curveDesc);
+    p1.propstr("xlabel","Fermi-Dirac Factor");
+    p1.propstr("ylabel","Energy");
+    p1.propstr("yunits","eV");
+
+    lib.result();
+
+    return 0;
+}
+
+
+if __name__ == '__main__':
+    sys.exit(main())
+
Index: trunk/examples/objects/app-fermi/fermi4.tcl
===================================================================
--- trunk/examples/objects/app-fermi/fermi4.tcl	(revision 1581)
+++ trunk/examples/objects/app-fermi/fermi4.tcl	(revision 1581)
@@ -0,0 +1,68 @@
+# ----------------------------------------------------------------------
+#  EXAMPLE: Fermi-Dirac function in Tcl.
+#
+#  This simple example shows how to use Rappture within a simulator
+#  written in Tcl.
+# ======================================================================
+#  AUTHOR:  Derrick Kearney, Purdue University
+#  Copyright (c) 2005-2009  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+# ======================================================================
+package require Rappture
+
+# open the XML file containing the run parameters
+set lib [Rappture::Library [lindex $argv 0]]
+
+if {[$lib error] != 0} {
+    # cannot open file or out of memory
+    puts stderr [$lib traceback]
+    exit [$lib error]
+}
+
+set T [Rappture::connect $lib "temperature"]
+set Ef [$lib value "Ef" "units=eV"]
+
+if {[$lib error != 0]} {
+    # there were errors while retrieving input data values
+    # dump the tracepack
+    puts stderr [$lib traceback]
+    exit [$lib error]
+}
+
+set nPts 200
+
+set kT [expr {8.61734e-5 * [$T value "K"]}]
+set Emin [expr {$Ef - 10*$kT}]
+set Emax [expr {$Ef + 10*$kT}]
+
+set dE [expr {0.005*($Emax-$Emin)}]
+
+set E $Emin
+for {set idx 0} {idx < nPts} {incr idx} {
+    set E [expr {$E + $dE}]
+    set f [expr {1.0/(1.0 + exp(($E - $Ef)/$kT))}]
+    lappend fArr $f
+    lappend Err $E
+    set progress [expr {(($E - $Emin)/($Emax - $Emin)*100)}]
+    Rappture::Utils::progress $progress -mesg "Iterating"
+}
+
+set curveLabel "Fermi-Dirac Curve"
+set curveDesc "Plot of Fermi-Dirac Calculation"
+
+# do it the easy way,
+# create a plot to add to the library
+# plot is registered with lib upon object creation
+# p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
+
+set p1 [Rappture::Plot $lib]
+$p1 add $nPts $fArr $EArr "" $curveLabel $curveDesc
+$p1 propstr "xlabel" "Fermi-Dirac Factor"
+$p1 propstr "ylabel" "Energy"
+$p1 propstr "yunits" "eV"
+
+$lib result
+
+exit 0
Index: trunk/examples/objects/library/library.cc
===================================================================
--- trunk/examples/objects/library/library.cc	(revision 1569)
+++ trunk/examples/objects/library/library.cc	(revision 1581)
@@ -1,11 +1,11 @@
 #include <iostream>
-#include <errno.h>
 #include "RpLibObj.h"
 #include "RpInt.h"
 #include "RpChain.h"
+#include "RpTest.h"
 
 int library_0_0 ()
 {
-    const char *testdesc = "test creating library object";
+    const char *testdesc = "test creating library object with loadFile()";
     const char *testname = "library_0_0";
     const char *filePath = "library_0_0_in.xml";
@@ -13,106 +13,328 @@
 
     Rappture::Library lib;
+
+    lib.loadFile(filePath);
+
+    const char *expected = NULL;
+
+    readFile(filePath, &expected);
+    const char *received = lib.xml();
+
+    retVal |= testStringVal(testname,testdesc,expected,received);
+
+    delete expected;
+
+    return retVal;
+}
+
+int library_0_1 ()
+{
+    const char *testdesc = "test creating library object with loadXml()";
+    const char *testname = "library_0_1";
+    int retVal = 0;
+
+    Rappture::Library lib;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\n\
+<run>\n\
+    <input>\n\
+        <number id=\"Ef\">\n\
+            <about>\n\
+                <label>Fermi Level</label>\n\
+                <description>Energy at center of distribution.</description>\n\
+            </about>\n\
+            <units>eV</units>\n\
+            <min>-10eV</min>\n\
+            <max>10eV</max>\n\
+            <default>0eV</default>\n\
+            <current>5eV</current>\n\
+            <preset>\n\
+                <label>300K (room temperature)</label>\n\
+                <value>300K</value>\n\
+            </preset>\n\
+            <preset>\n\
+                <label>77K (liquid nitrogen)</label>\n\
+                <value>77K</value>\n\
+            </preset>\n\
+            <preset>\n\
+                <label>4.2K (liquid helium)</label>\n\
+                <value>4.2K</value>\n\
+            </preset>\n\
+        </number>\n\
+    </input>\n\
+</run>\n\
+";
+
+    lib.loadXml(buf);
+
+    const char *expected = buf;
+    const char *received = lib.xml();
+
+    retVal |= testStringVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
+
+int library_1_0 ()
+{
+    const char *testdesc = "test contains() function on empty library";
+    const char *testname = "library_1_0";
+    int retVal = 0;
+
+    Rappture::Library lib;
     const Rp_Chain *contents = NULL;
-
-    lib.loadFile(filePath);
     contents = lib.contains();
 
-    std::printf("lib contains %d item(s)\n", Rp_ChainGetLength(contents));
-
-    return retVal;
-}
-
-int library_1_0 ()
-{
-    const char *testdesc = "test creating library object";
-    const char *testname = "library_1_0";
-    const char *filePath = "library_0_0_in.xml";
+    int expected = 0;
+    int received = Rp_ChainGetLength(contents);
+
+    retVal |= testDoubleVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
+
+int library_1_1 ()
+{
+    const char *testdesc = "test contains() function on populated library";
+    const char *testname = "library_1_1";
     int retVal = 0;
 
     Rappture::Library lib;
     const Rp_Chain *contents = NULL;
-
-    lib.loadFile(filePath);
-
-    const char *xmltext = lib.xml();
-    printf("xmltext = %s\n",xmltext);
-
-    return retVal;
-}
-
-/*
-int number_0_1 ()
-{
-    const char *testdesc = "test number constuctor";
-    const char *testname = "number_0_0";
-    int retVal = 0;
-
-    const char *name = "eV";
-    const char *units = "eV";
-    double def = 1.4;
-
-    Rappture::Number *n = NULL;
-
-    n = new Rappture::Number(name,units,def);
-
-    if (n == NULL) {
-        printf("Error: %s\n", testname);
-        printf("\t%s\n", testdesc);
-        printf("\terror creating number object\n");
-        retVal = 1;
-    }
-
-    retVal |= testStringVal(testname,testdesc,name,n->name());
-    retVal |= testStringVal(testname,testdesc,units,n->units());
-    retVal |= testDoubleVal(testname,testdesc,def,n->def());
-
-    if (n != NULL) {
-        delete n;
-    }
-
-    return retVal;
-}
-
-int number_1_0 ()
-{
-    const char *testdesc = "test constructing number from xml";
-    const char *testname = "number_1_0";
-    const char *filePath = "number_1_0_in.xml";
-    int retVal = 0;
-
-    const char *buf = NULL;
-    readFile(filePath,&buf);
-
-    const char *name = "Ef";
-    const char *units = "eV";
-    double def = 0;
-    double cur = 5;
-    double min = -10;
-    double max = 10;
-    const char *label = "Fermi Level";
-    const char *desc = "Energy at center of distribution.";
-
-    Rappture::Number n;
-
-    n.xml(buf);
-
-    retVal |= testStringVal(testname,testdesc,name,n.name());
-    retVal |= testStringVal(testname,testdesc,units,n.units());
-    retVal |= testDoubleVal(testname,testdesc,def,n.def());
-    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
-    retVal |= testDoubleVal(testname,testdesc,min,n.min());
-    retVal |= testDoubleVal(testname,testdesc,max,n.max());
-    retVal |= testStringVal(testname,testdesc,label,n.label());
-    retVal |= testStringVal(testname,testdesc,desc,n.desc());
-
-    return retVal;
-}
-*/
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<run>\
+    <input>\
+        <number id=\"Ef\">\
+            <about>\
+                <label>Fermi Level</label>\
+                <description>Energy at center of distribution.</description>\
+            </about>\
+            <units>eV</units>\
+            <min>-10eV</min>\
+            <max>10eV</max>\
+            <default>0eV</default>\
+            <current>5eV</current>\
+            <preset>\
+                <value>300K</value>\
+                <label>300K (room temperature)</label>\
+            </preset>\
+            <preset>\
+                <value>77K</value>\
+                <label>77K (liquid nitrogen)</label>\
+            </preset>\
+            <preset>\
+                <value>4.2K</value>\
+                <label>4.2K (liquid helium)</label>\
+            </preset>\
+        </number>\
+    </input>\
+</run>";
+
+    lib.loadXml(buf);
+    contents = lib.contains();
+
+    int expected = 1;
+    int received = Rp_ChainGetLength(contents);
+
+    retVal |= testDoubleVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
+
+int library_2_0 ()
+{
+    const char *testdesc = "test value(), 0 hints";
+    const char *testname = "library_2_0";
+    int retVal = 0;
+
+    Rappture::Library lib;
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<run>\
+    <input>\
+        <number id=\"temperature\">\
+            <about>\
+                <label>Ambient temperature</label>\
+                <description>Temperature of the environment.</description>\
+            </about>\
+            <units>K</units>\
+            <min>0K</min>\
+            <max>500K</max>\
+            <default>300K</default>\
+        </number>\
+        <number id=\"Ef\">\
+            <about>\
+                <label>Fermi Level</label>\
+                <description>Energy at center of distribution.</description>\
+            </about>\
+            <units>eV</units>\
+            <min>-10eV</min>\
+            <max>10eV</max>\
+            <default>4eV</default>\
+        </number>\
+    </input>\
+</run>";
+
+    lib.loadXml(buf);
+
+    double expected = 4.0;
+    double received = 0.0;
+    lib.value("Ef",&received,0);
+
+    retVal |= testDoubleVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
+
+int library_2_1 ()
+{
+    const char *testdesc = "test value(), 1 hint, units=eV";
+    const char *testname = "library_2_1";
+    int retVal = 0;
+
+    Rappture::Library lib;
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<run>\
+    <input>\
+        <number id=\"temperature\">\
+            <about>\
+                <label>Ambient temperature</label>\
+                <description>Temperature of the environment.</description>\
+            </about>\
+            <units>K</units>\
+            <min>0K</min>\
+            <max>500K</max>\
+            <default>300K</default>\
+        </number>\
+        <number id=\"Ef\">\
+            <about>\
+                <label>Fermi Level</label>\
+                <description>Energy at center of distribution.</description>\
+            </about>\
+            <units>eV</units>\
+            <min>-10eV</min>\
+            <max>10eV</max>\
+            <default>4eV</default>\
+        </number>\
+    </input>\
+</run>";
+
+    lib.loadXml(buf);
+
+    double expected = 4.0;
+    double received = 0.0;
+    lib.value("Ef",&received,1,"units=eV");
+
+    retVal |= testDoubleVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
+
+int library_2_2 ()
+{
+    const char *testdesc = "test value(), 1 hint, units=J";
+    const char *testname = "library_2_2";
+    int retVal = 0;
+
+    Rappture::Library lib;
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<run>\
+    <input>\
+        <number id=\"temperature\">\
+            <about>\
+                <label>Ambient temperature</label>\
+                <description>Temperature of the environment.</description>\
+            </about>\
+            <units>K</units>\
+            <min>0K</min>\
+            <max>500K</max>\
+            <default>300K</default>\
+        </number>\
+        <number id=\"Ef\">\
+            <about>\
+                <label>Fermi Level</label>\
+                <description>Energy at center of distribution.</description>\
+            </about>\
+            <units>eV</units>\
+            <min>-10eV</min>\
+            <max>10eV</max>\
+            <default>4eV</default>\
+        </number>\
+    </input>\
+</run>";
+
+    lib.loadXml(buf);
+
+    // double expected = 6.40871e-19;
+    double expected = 4*1.602177e-19;
+    double received = 0.0;
+    lib.value("Ef",&received,1,"units=J");
+
+    retVal |= testDoubleVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
+
+int library_2_3 ()
+{
+    const char *testdesc = "test value(), object does not exist";
+    const char *testname = "library_2_3";
+    int retVal = 0;
+
+    Rappture::Library lib;
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<run>\
+    <input>\
+        <number id=\"temperature\">\
+            <about>\
+                <label>Ambient temperature</label>\
+                <description>Temperature of the environment.</description>\
+            </about>\
+            <units>K</units>\
+            <min>0K</min>\
+            <max>500K</max>\
+            <default>300K</default>\
+        </number>\
+        <number id=\"Ef\">\
+            <about>\
+                <label>Fermi Level</label>\
+                <description>Energy at center of distribution.</description>\
+            </about>\
+            <units>eV</units>\
+            <min>-10eV</min>\
+            <max>10eV</max>\
+            <default>4eV</default>\
+        </number>\
+    </input>\
+</run>";
+
+    lib.loadXml(buf);
+
+    // library should not change the value of received
+    // if it cannot find the requested object
+    double expected = -101.01;
+    double received = -101.01;
+    lib.value("EF",&received,1,"units=J");
+
+    retVal |= testDoubleVal(testname,testdesc,1,lib.error());
+    retVal |= testDoubleVal(testname,testdesc,expected,received);
+
+    return retVal;
+}
 
 int main()
 {
     library_0_0();
-    // library_0_1();
+    library_0_1();
     library_1_0();
+    library_2_0();
+    library_2_1();
+    library_2_2();
+    library_2_3();
 
     return 0;
